#include <iostream> 
#include "polygon.hpp"
#include "regular_polygon.hpp"

// Zachecam do sprawdzenia ile razy alokowana jest pamiec w kazdym z przypadkow testujacych.
// Zachecam do zakomentowania konstruktora przenoszacego oraz przenoszacego operatora przypisania 
// i porownania otrzymanych wartosci

auto getPolygon(size_t size = 5)
{
    auto result = Polygon(size);
    for (auto i = 0.0; i < size; ++i)
    {

        result.push({ i , i * i});
    }

    return result;
}

auto getRegularPolygon(size_t size = 5)
{
    return RegularPolygon(size, 1.0);
}

void doSomethingWithPolygonByReference(const Polygon& polygon)
{
    for (auto i = 0; i < polygon.numberOfPoints(); ++i)
    {
        std::cout << "<" << polygon[i].x << "," << polygon[i].y << ">";
    }
    std::cout << "\n";
}

void doSomethingWithRegularPolygonByReference(const RegularPolygon& polygon)
{
    for (auto i = 0; i < polygon.numberOfPoints(); ++i)
    {
        std::cout << "<" << polygon[i].x << "," << polygon[i].y << ">";
    }
    std::cout << "\n";
}

void doSomethingWithPolygonByValue(Polygon polygon)
{
    doSomethingWithPolygonByReference(polygon);
}

void test_polygon_1()
{
    std::cout << "__TEST__ 1 \n";
    auto polygon = getPolygon();
    doSomethingWithPolygonByReference(polygon);
}

void test_polygon_2()
{
    std::cout << "__TEST__ 2 \n\n";
    doSomethingWithPolygonByReference(getPolygon());
}

void test_polygon_3()
{
    std::cout << "__TEST__ 3 \n";
    auto polygon = getPolygon();
    doSomethingWithPolygonByValue(polygon);
}

void test_polygon_4()
{
    std::cout << "__TEST__ 4 \n";
    doSomethingWithPolygonByValue(getPolygon());
}

void test_polygon_5()
{
    std::cout << "__TEST__ 5 \n";
    doSomethingWithPolygonByReference(getPolygon());
}

void test_polygon_6()
{
    std::cout << "__TEST__ 6 \n";

    auto polygon1 = getPolygon();
    auto polygon2 = getPolygon();
    polygon1 = polygon2;
}

void test_polygon_7()
{
    std::cout << "__TEST__ 7 \n";

    auto polygon1 = getPolygon();
    polygon1 = getPolygon();

}

void test_regular_polygon_1()
{
    std::cout << "__TEST__ 7 \n";
    doSomethingWithRegularPolygonByReference(getRegularPolygon());
}

int main(void)
{
    test_polygon_1(); std::cout << "\n";
    test_polygon_2(); std::cout << "\n";
    test_polygon_3(); std::cout << "\n";
    test_polygon_4(); std::cout << "\n";
    test_polygon_5(); std::cout << "\n";
    test_polygon_6(); std::cout << "\n";
    test_polygon_7(); std::cout << "\n";
    test_regular_polygon_1(); std::cout << "\n";

    getchar();
    return 0;
}