#include "regular_polygon.hpp"

#include <cmath>

RegularPolygon::RegularPolygon(size_t number_of_edges, double radius)
    : polygon_(number_of_edges)
{
    static const double pi = std::acos(-1);

    for (auto i = 0; i < number_of_edges; i++)
    {
        polygon_.push({ radius * std::cos(i * 2 * pi / number_of_edges),
            radius * std::sin(i * 2 * pi / number_of_edges) });
    }
}

size_t RegularPolygon::numberOfPoints() const
{
    return polygon_.numberOfPoints();
}

Point & RegularPolygon::operator[](size_t index)
{
    return polygon_[index];
}

Point RegularPolygon::operator[](size_t index) const
{
    return polygon_[index];
}
